/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __STREAM_H
#define __STREAM_H

#define BUFFER_WIDE 0x100

//Bei Full gesetzt      -> 1
//Bei Empty rckgesetzt -> 0

#define DOUBLE_BUFFER_1_SET_FULL()   	(u8DoubleBufferCommunicationControl |= 0x01)
#define DOUBLE_BUFFER_1_SET_EMPTY()  	(u8DoubleBufferCommunicationControl &= 0xFE)
#define DOUBLE_BUFFER_2_SET_FULL()   	(u8DoubleBufferCommunicationControl |= 0x02)
#define DOUBLE_BUFFER_2_SET_EMPTY()  	(u8DoubleBufferCommunicationControl &= 0xFD)

#define DOUBLE_BUFFER_1_FULL()	  		(u8DoubleBufferCommunicationControl   & 0x01)	
#define DOUBLE_BUFFER_1_EMPTY()			(~(u8DoubleBufferCommunicationControl)  & 0x01)
#define DOUBLE_BUFFER_2_FULL()			(u8DoubleBufferCommunicationControl  & 0x02)/2
#define DOUBLE_BUFFER_2_EMPTY()			(~(u8DoubleBufferCommunicationControl) & 0x02)/2


#define DOUBLE_BUFFER_1_SET_READY()   		(u8DoubleBufferDSPControl |= 0x01)
#define DOUBLE_BUFFER_1_SET_NOT_READY()  	(u8DoubleBufferDSPControl &= 0xFE)
#define DOUBLE_BUFFER_2_SET_READY()   		(u8DoubleBufferDSPControl |= 0x02)
#define DOUBLE_BUFFER_2_SET_NOT_READY() 	(u8DoubleBufferDSPControl &= 0xFD)

#define DOUBLE_BUFFER_1_READY()  			(u8DoubleBufferDSPControl   & 0x01)	
#define DOUBLE_BUFFER_1_NOT_READY()			(~(u8DoubleBufferDSPControl)  & 0x01)
#define DOUBLE_BUFFER_2_READY()				(u8DoubleBufferDSPControl  & 0x02)/2
#define DOUBLE_BUFFER_2_NOT_READY()			(~(u8DoubleBufferDSPControl) & 0x02)/2

#endif  /*__GLOBAL_H*/
