#ifndef __DMA_USER_H
#define __DMA_USER_H

/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "global.h"
#include "stream.h"

/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __DMA_USER_C
  #define LINKTYPE_DMA_USER  
#else
  #define LINKTYPE_DMA_USER extern
#endif // #ifdef __DMA_USER_C


/******************************************************************************************************/
/*                                           Globale Defines                                          */
/******************************************************************************************************/
#define DMA_Channel_SPI_SD_RX 	DMA1_Channel2
#define DMA_Channel_SPI_SD_TX   DMA1_Channel3
	 

/*********************************************************************************************/
/*                                     Globale Variablen                                     */
/*********************************************************************************************/
LINKTYPE_DMA_USER uint8_t u8DoubleBufferDSPControl;

LINKTYPE_DMA_USER uint16_t u16DoubleBuffer1[BUFFER_WIDE];
LINKTYPE_DMA_USER uint16_t u16DoubleBuffer2[BUFFER_WIDE];
LINKTYPE_DMA_USER uint16_t u16MasterOutBuffer[BUFFER_WIDE*2];
LINKTYPE_DMA_USER uint16_t u16MasterBufferDataSize;

LINKTYPE_DMA_USER uint16_t u16BytesToTransferPerDMACycle;
LINKTYPE_DMA_USER uint32_t u32JumpAdressDuringBufferChanging;

LINKTYPE_DMA_USER uint8_t  u8DoubleBufferCommunicationControl;

LINKTYPE_DMA_USER uint16_t u16CountOfModifideDatasBuffer1;
LINKTYPE_DMA_USER uint16_t u16CountOfModifideDatasBuffer2;

LINKTYPE_DMA_USER float 	fQuantisationTime;
LINKTYPE_DMA_USER float 	fSkalierungsfaktorXAchse;

LINKTYPE_DMA_USER uint32_t u32CounterOfDMAStreamedDatas;

 
/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
void init_DMA (void);
void DMAVarInit (void);
void RCC_Configuration_DMA(void);
void NVIC_Configuration_DMA(void);
void StartDMATransferToBuffer (uint16_t Titel);
void CopyDoubleBufferToTimerBuffer (void);
void DMA1_Channel2_IRQHandler (void);
void StartDMATransferToSpeaker (uint16_t u16Stepwide);
void StopDMATransferToSpeaker (void);

#undef LINKTYPE

#endif
