/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __DSP_H
#define __DSP_H


/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "stream.h"
#include "stdint.h"

/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __DSP_C
  #define LINKTYPE  
#else
  #define LINKTYPE extern
#endif // #ifdef __DSP_C

/******************************************************************************************************/
/*                                           Globale Defines                                          */
/******************************************************************************************************/
#define METADATALENGH  0x2C

#define	CHUNKSIZE1 4 
#define	CHUNKSIZE2 5
#define	CHUNKSIZE3 6
#define	CHUNKSIZE4 7

#define NUMCHANNELS1   22  //Byte 22
#define NUMCHANNELS2   23  //Byte 23 

#define BYTERATE1	   28
#define BYTERATE2	   29
#define BYTERATE3	   30
#define BYTERATE4	   31	

#define	BLOCKALIGN1    32		       
#define	BLOCKALIGN2    33

#define	SUBCHUNK2SIZE1 40 
#define	SUBCHUNK2SIZE2 41
#define	SUBCHUNK2SIZE3 42
#define	SUBCHUNK2SIZE4 43


#define TWOBYTEPERCHANNELSTEREO	  0x04
#define ONEBYTEPERCHANNELSTEREO   0x02

#define TWOBYTEPERCHANNELMONO	  0x02
#define ONEBYTEPERCHANNELMONO	  0x01

#define FIX_SAMPLING 0
#define FIX_QUANTIFICATION 1

/*********************************************************************************************/
/*                              Globale Variablen				                             */
/*********************************************************************************************/
LINKTYPE uint8_t u8EngoingStatus;
LINKTYPE uint16_t u16EngoingSinusFrequenz;
LINKTYPE uint8_t u8EngoingFixSampling0OrQuantisation;
LINKTYPE uint16_t u16EngoingFixValue;
LINKTYPE uint16_t u16EngoingLevelInPercent;

/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
extern uint16_t 		u16Titel_Counter;
void DSPConvertStereoToMono(uint8_t u8Titel);
void Sinus (uint16_t u16SinusFrequenz, uint16_t u16FixSampling0OrQuantisation, uint16_t u16FixValue, uint8_t u8LevelInPercent);
void InitTesttone (void);
void DSPPlayTitel(uint8_t u8Titel);
#endif 
