/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __GLOBAL_H
#define __GLOBAL_H


#include "stdint.h"
/* Global variables --------------------------------------------------------*/
#define TIMFREQUENZ 72000000

#define MONO   1
#define STEREO 2


#define MAXZAHLEN	  10
#define BUFFER_VALUE 256  
#define PAGESIZE	 255  


#define RECEIVE     1
#define TRANSFERE 	0
/*
0x00 Startbedingung Daten werden in User_Commands_From_PC gespeichert
0x01 Durch drcken von 0x0D wird der Starttext ausgegeben 
0x02 Komandoempfangs werden angenommen
0x03 Durch drcken von 0x30 wird auf Datentransfer umgeschalten
0x04 Durch drcken von 0x31 kann die Samplingfrequenz gendert werden
0x05 Durch drcken von 0x32 kann die Anz. der Quantisierungsstufen gendert werden
*/
//Defines for StateMaschine
#define COMMUNICATION_DETECTED			0
#define START_COMMUNICATION				1
#define EXCEPT_SUBCOMMANDS				2
#define EXCEPT_TESTINFOS				3
#define RECIVE_NEW_AUDIOFILES			4		
#define RECIVE_NEW_SAMPLINGFREQUENZ		5		
#define RECIVE_NEW_QUANTISATION_STEPS	6
#define GET_USER_TITEL_WISH				7
		

//Defines for User_Sub_Commands_From_PC
//Recived from User
#define ALL_DONE						0x00
#define TEST_TONE_ON					0x01	
#define WILL_SEND_AUDIO_FILE			0x30	
#define WILL_SEND_NEW_SAMPLINGFREQUENZ	0x31
#define WILL_SEND_QUANTISATION_STEPS	0x32		
#define ERASE_ALL						0x33
#define INFO_PAGE						0x34
#define RETURN_ONE_TITLE				0x35
#define RETURN_ALL_TITELS				0x36
#define STEREO_TO_MONO_CONVERT			0x37
#define PLAY_TITLE						0x38
#define TEST_TONE_CONTROL				0x39


#define TEST_TONE_STATUS				0x30
#define TEST_TONE_ACTIVATE				0x31
#define TEST_TONE_FREQUENZ				0x32
#define TEST_TONE_QORS					0x33
#define TEST_TONE_LEVEL					0x34
#define TEST_TONE_LEAVE					0x35

#define TEST_TONE_FIX_VALUE_SF			0x30
#define TEST_TONE_FIX_VALUE_QUANT		0x31

		


static uint32_t u32MaxByteSize =  0x007A1200; //8MB Speicher des 

//Defines for Internal Flash
#define FIRST_AREA 0

//Defines for external Flash
#define  sFLASH_ID       sFLASH_M25P64_ID
#define  Buffer0 		1
#define  Buffer1        2



//Strukturen
static struct Textinfo
{
	uint8_t size;
	uint8_t Text[BUFFER_VALUE]; // erstellen des Arrays
}sText;


static struct Numberinfo
{
	uint8_t size;
	uint8_t Text[MAXZAHLEN]; // erstellen des Arrays
}sNumber;

#endif  /*__GLOBAL_H*/
