/******************** (C) COPYRIGHT 2010 STMicroelectronics ********************
* File Name          : hw_config.h
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 04/07/2010
* Description        : Hardware Configuration & Setup
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __HW_CONFIG_H
#define __HW_CONFIG_H

/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "global.h"
#include "usb_type.h"
#include "usb_desc.h"

/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __HW_CONFIG_C
  #define LINKTYPE_HW_CONFIG 
#else
  #define LINKTYPE_HW_CONFIG extern
#endif // #ifdef __HW_CONFIG_C



/******************************************************************************************************/
/*                                           Globale Defines                                          */
/******************************************************************************************************/
#define MASS_MEMORY_START     0x04002000
#define BULK_MAX_PACKET_SIZE  0x00000040
#define LED_ON                0xF0
#define LED_OFF               0xFF

/*********************************************************************************************/
/*                              Globale Variablen                               */
/*********************************************************************************************/
LINKTYPE_HW_CONFIG uint8_t  u8User_Buffer_Datas_From_PC0[BUFFER_VALUE];
LINKTYPE_HW_CONFIG uint8_t  u8User_Buffer_Datas_From_PC1[BUFFER_VALUE];
LINKTYPE_HW_CONFIG uint16_t u16Counter_Datas_From_PC0;
LINKTYPE_HW_CONFIG uint16_t u16Counter_Datas_From_PC1 ;
LINKTYPE_HW_CONFIG uint64_t u64Audio_Total_Byte_Counter;
LINKTYPE_HW_CONFIG uint32_t	u32Audio_Byte_Counter_Max_Value;
LINKTYPE_HW_CONFIG uint16_t u16Areas_Needed_For_File;
LINKTYPE_HW_CONFIG uint16_t u16Titel_Counter;

LINKTYPE_HW_CONFIG uint8_t 	u8User_Commands_From_PC;
LINKTYPE_HW_CONFIG uint8_t 	u8User_Sub_Commands_From_PC;
LINKTYPE_HW_CONFIG uint8_t 	u8User_Sub_Commands_For_Testtone;
LINKTYPE_HW_CONFIG uint8_t 	u8StateMaschine;
LINKTYPE_HW_CONFIG uint8_t	u8UserTitelNumber;
LINKTYPE_HW_CONFIG uint8_t	u8UserDatasForTesttone;

LINKTYPE_HW_CONFIG uint8_t buffer_in[VIRTUAL_COM_PORT_DATA_SIZE];






/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
void VarInit_HW_Config (void);
void Set_System(void);
void Set_USBClock(void);
void Enter_LowPowerMode(void);
void Leave_LowPowerMode(void);
void USB_Interrupts_Config(void);
void USB_Cable_Config (FunctionalState NewState);
void USART_Config_Default(void);
bool USART_Config(void);
void USB_To_User_Buffer_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void User_Buffer_to_USB_Send_Data(uint8_t* data_buffer, uint8_t Nb_bytes);
void Get_SerialNum(void);

void SaveRecivedDatas(void);

/* External variables --------------------------------------------------------*/

#endif  /*__HW_CONFIG_H*/
/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
