/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __GUI_USER_COMMANDS_FROM_PC_H
#define __GUI_USER_COMMANDS_FROM_PC_H


/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/

#include "stdint.h"


/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __MENUE_GUI_C
  #define LINKTYPE_MENUE_GUI  
#else
  #define LINKTYPE_MENUE_GUI extern
#endif // #ifdef __MENUE_GUI_C


/******************************************************************************************************/
/*                                           Globale Defines                                          */
/******************************************************************************************************/
#define     __IO    volatile                  /*!< defines 'read / write' permissions   */
#define 	VIRTUAL_COM_PORT_DATA_SIZE              64


/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
//FUNCTIONPROTOTYPES
void GUIUserCommandsFromPC (void);
void GUIUserCommandsForTestSinus (void);
void GUIWillSendAudioFileSDOK (void);
void GUIWillSendAudioFileSDNotOK (void);
void GUIWillSendNewSamplingfrequenz (void);
void GUIWillSendNewQuantisationSteps (void);
void GUIEraseAllStart(void);
void GUIEraseAllFinish(void);
void GUIInfoPage(void);
void GUIInfoPage (void);
void GUIReturnOneTitel(uint8_t Titel);
void GUIReturnAllTitels(void);
uint8_t GUIGetUserTitelWish(void);

void GUIConvertStereoToMono(uint8_t u8Titel);

void GUIReturnNoTitelOnFlash(void);
void GUIReturnTitelNotOnFlash(void);

void GUIBlocklengh_Not_Supported (void);

void GUIFileIsMonoConversioDontNeeded (void);
void GUIFileConverted(void);

void GUIPlayTitel(uint16_t u16Titel);

extern void SPI_FLASH_BufferWrite(uint8_t* pBuffer, uint32_t WriteAddr, uint16_t NumByteToWrite);
extern void SPI_FLASH_BufferRead(uint8_t* pBuffer, uint32_t ReadAddr, uint16_t NumByteToRead);
void PrepareFlashToRead (uint32_t u32ReadAddr);
extern void DeselectFlash (void);
extern uint8_t SPI_FLASH_SendByte(uint8_t byte);

//DSP
void GUIFunctionNotSupported(void);
void GUISameSamplingFrequenz(void);
void GUINewSamplingFrequenzSmalerThanOrginal (void);

void GUITestTonStatus (void);
void GUITestTonOnOff (void);
void GUIConfigTestToneFrequenz(void);
void GUIConfigTestToneChangeValue(void);
void GUIConfigTestToneVolumen(void);
void GUIConfigParametricValue(void);
void GUILeaveTestMode (void);
void ClearLastCaracter (void);

#endif  /*__GUI_USER_COMMANDS_FROM_PC_H*/ 

