/******************** (C) COPYRIGHT 2010 STMicroelectronics ********************
* File Name          : hw_config.h
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 04/07/2010
* Description        : Hardware Configuration & Setup
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Define to prevent recursive inclusion -------------------------------------*/
#ifndef __USB_ENDP_H
#define __USB_ENDP_H

/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "global.h"
#include "usb_type.h"
#include "usb_desc.h"

/******************************************************************************************************/
/* Festlegen, ob Variablen und Funktionen als "extern" deklariert werden muessen                      */
/******************************************************************************************************/
#ifdef __USB_ENDP_C
  #define LINKTYPE_USB_ENDP 
#else
  #define LINKTYPE_USB_ENDP extern
#endif // #ifdef __USB_ENDP_C



/******************************************************************************************************/
/*                                           Globale Defines                                          */
/******************************************************************************************************/
#define     __IO    volatile                  /*!< defines 'read / write' permissions   */

/*********************************************************************************************/
/*                              Globale Variablen                               */
/*********************************************************************************************/
LINKTYPE_USB_ENDP uint8_t u8Buffer_Out[VIRTUAL_COM_PORT_DATA_SIZE];
LINKTYPE_USB_ENDP __IO uint32_t u32Count_Out;
LINKTYPE_USB_ENDP uint32_t count_in;

LINKTYPE_USB_ENDP uint8_t u8BufferControl;
LINKTYPE_USB_ENDP uint8_t u8BufferFilled;
LINKTYPE_USB_ENDP uint8_t u8EndOfFile;



/*********************************************************************************************/
/*                              Globale Funktionsdeklarationen                               */
/*********************************************************************************************/
void VarInit_USBEndp (void);

/* External variables --------------------------------------------------------*/

#endif  /*__HW_CONFIG_H*/
/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/
