#define __SUB_MENUE_C

#include "global.h"
#include "sub_menue.h"
#include "hw_config.h"
#include "menue_gui.h"

/**
  * \brief  TestToneSubMenue
  *
  * Submen zum steuern des Sinustesttons
  * Hier knnen die Samplingfrequenz und die Quantisierung sowie die 
  * Lautstrke und die Sinusfrequenz verndert werden. 
  *
  * \param	parameter   none
  * \return	            none
  *
  */

void TestToneSubMenue (void)
{
	/**********************************************************
	 GUI um Testtonstatus auszugeben
	**********************************************************/
	if(u8User_Sub_Commands_For_Testtone == TEST_TONE_STATUS)
	{
		GUITestTonStatus();
		GUIUserCommandsForTestSinus();
		u8User_Sub_Commands_From_PC = TEST_TONE_ON;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;	
	}
	/**********************************************************
	 GUI um Testtonstatus zu aktivieren
	**********************************************************/
	if(u8User_Sub_Commands_For_Testtone == TEST_TONE_ACTIVATE)
	{
		GUITestTonOnOff();
		GUIUserCommandsForTestSinus();
		u8User_Sub_Commands_From_PC = TEST_TONE_ON;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;	
	}
	/**********************************************************
	 GUI um Testtonfrequenz
	**********************************************************/
	else if(u8User_Sub_Commands_For_Testtone == TEST_TONE_FREQUENZ)
	{
		GUIConfigTestToneFrequenz();
		GUIUserCommandsForTestSinus();
		u8User_Sub_Commands_From_PC = TEST_TONE_CONTROL;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;	
	}
	/**********************************************************
	 GUI um Q or S zu aendern
	**********************************************************/
	else if(u8User_Sub_Commands_For_Testtone == TEST_TONE_QORS)
	{
		GUIConfigTestToneChangeValue();
		GUIUserCommandsForTestSinus();
		u8User_Sub_Commands_From_PC = TEST_TONE_CONTROL;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;	
	}
	/**********************************************************
	 GUI um Testtonlautstrke zu setzen
	**********************************************************/
	else if(u8User_Sub_Commands_For_Testtone == TEST_TONE_LEVEL)
	{
		GUIConfigTestToneVolumen();
		GUIUserCommandsForTestSinus();
		u8User_Sub_Commands_From_PC = TEST_TONE_CONTROL;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;	
	}
	/**********************************************************
	 GUI um das Testmenue zu verlassen
	**********************************************************/
	else if(u8User_Sub_Commands_For_Testtone == TEST_TONE_LEAVE)
	{
		GUILeaveTestMode();	
		u8User_Sub_Commands_From_PC = ALL_DONE;
		u8User_Sub_Commands_For_Testtone = ALL_DONE;
	}
}

#undef __SUB_MENUE_C   
