#define __DSP_C

#define TESTSINUS_ON


#define DSP_CONVERT_OFF
/******************************************************************************************************/
/*                                              Includes                                              */
/******************************************************************************************************/
#include "global.h"
#include "dsp.h"
#include "menue_gui.h"
#include "spi_flash.h"
#include "internal_flash.h"
#include "dma_user.h"
#include "stream.h"

#include "dma_user.h"
#include "timer_pwm.h"

#include "math.h"

#pragma O3

/**
  * \brief  DSPConvertStereoToMono
  *
  * Konvertiert ein Stereosignal in ein Monosignal
  * und speichert dieses als neues file in das externe Flash
  *
  * \param	parameter   uint8_t u8Titel
  * \return	            none
  *
  */

void DSPConvertStereoToMono(uint8_t u8Titel)
{
//	uint8_t u8NumberOfOrginalTitel = u8Titel; 
//
//	uint8_t u8Byte1;
//	uint8_t u8Byte2;
//	uint8_t u8Byte3;
//	uint8_t u8Byte4;
//	uint8_t u8NutzdatenCounter = 0;
//
//	uint16_t u16BlockAlign;
//	uint16_t u16PageCounter = 0;
//
//	uint32_t u32Subchunk2Size; 
//	uint32_t u32ChunkSize;
//	uint32_t u32ByteRate;
//	uint32_t u32StartAddrOfOrginalFile = get_StartAdress(u8Titel-1); 
//	uint32_t u32StartAddrForConvertedFile = get_EndAdress((u16Titel_Counter-1))+1;	 //Ende des Vorherigen +1
//
//	uint8_t  u8MetaDataBuffer[METADATALENGH];
//
//			
//	uint16_t u16BytesPerBlock = get_BlockAlign(u8Titel-1);
//
//	uint16_t u16NumChannelsTemp;
//	uint16_t u16BlockAlignTemp;
//			
//	uint32_t u32DataReadAddr = u32StartAddrOfOrginalFile;
//	uint32_t u32DataWriteAdress = u32StartAddrForConvertedFile;
//
//	uint32_t u32Subchunk2SizeTemp;
//	uint32_t u32ChunkSizeTemp;
//	uint32_t u32ByteRateTemp;
//
//	if(get_NumChannels(u8Titel-1) == STEREO)
//	{ 
//	
//		u16Titel_Counter++; //jetzt kommt ja ein neues File hinzu	
//		/**********************************************************
//		zuerst den Datenkopf Kopieren hierbei ist folgendes zu beachten:
//		 - Stereo auf Mono Stellen
//		 - lnge des Datenblocks halbieren
//		 - Adressen Manipulieren
//		 hierbei wird zuerst der komplette Orginalkopf kopiert 
//		 dann werden die einzelnen nderungen vorgenommen
//		**********************************************************/
//	
//		//Strukturen
//	/**
//	   Contains the Informations about the Titles
//	First Area Contains some informations about file
//					
//	* 	Change	Offset		Fild Name			Fild Size		Description		
//	* 	NO		   0		ChunkID			    	4			contains "RIFF"	(0x52494646 big-endian form
//	*	YES	J	   4		ChunkSize				4			Size from her to end (36+Size2)
//	*	NO		   8		Format					4			contains "WAVE" (0x57415645 big-endian form)
//	*	NO		  12		Subchunk1ID				4			contains "fmt" (0x666d7420 big-endian form
//	*	NO		  16		Subchunk1Size			4			0xF by PCM
//	*	NO		  20		AudioFormat				2			PCM = 0x01 all others are Compressed
//	*	YES	J	  22		NumChannels				2			0x01 Mono 0x02 Stereo
//	*	NO		  24		SampleRate				4			8000, 44100, etc.
//	*	YES	J	  28		ByteRate				4		    == SampleRate * NumChannels * BitsPerSample/8
//	*	YES	J	  32		BlockAlign				2			== NumChannels * BitsPerSample/8
//	*	NO		  34		BitsPerSample			2			8 bits = 8, 16 bits = 16, etc.
//	*	NO		  36		Subchunk2ID				4			contains "data"	 (0x64617461 big-endian form)
//	*	YES	J	  40		Subchunk2Size			4			== NumSamples * NumChannels * BitsPerSample/8
//	*	YES	J	  44	   	Datas		   	  Subchunk2Size
//	**/
//		
//		CopyStruck(u8Titel-1,u16Titel_Counter-1);
//	 	/**********************************************************
//		Hier folgt nun die Manipulation der Metadatren
//		**********************************************************/
//		//Setze Format auf Mono == 0x00
//		set_NumChannels(u16Titel_Counter-1, MONO , 0),
//	
//	
//		//Breite einer Stereoinfo ermitteln
//		//Diese setzt sich zusammen aus Rechtem UND linkem Kanal
//		//Also ist R bzw L je die Hlfte
//		u16BlockAlign = get_BlockAlign(u8NumberOfOrginalTitel-1);
//		u16BlockAlign = u16BlockAlign/2;
//		u8Byte1 = (uint8_t)(u16BlockAlign >> 8);
//		u8Byte2 = (uint8_t) u16BlockAlign	   ;
//		set_BlockAlign(u16Titel_Counter-1,u8Byte2,u8Byte1); 
//	
//		//Neue lnge des Datenblocks  == alte/2 da je zwei Stereoinfos (L&&R) ein Monobyte werden
//		u32Subchunk2Size = get_Subchunk2Size(u8NumberOfOrginalTitel-1);
//		u32Subchunk2Size = u32Subchunk2Size/2;
//		u8Byte1 = (uint8_t)(u32Subchunk2Size >> 24);
//		u8Byte2 = (uint8_t)(u32Subchunk2Size >> 16);
//		u8Byte3 = (uint8_t)(u32Subchunk2Size >> 8);
//		u8Byte4 =	(uint8_t) u32Subchunk2Size;
//		set_Subchunk2Size(u16Titel_Counter-1,u8Byte4, u8Byte3, u8Byte2, u8Byte1); 
//	
//		//Neue lnge des Files  == alte/2 da je zwei Stereoinfos (L&&R) ein Monobyte werden
//		u32ChunkSize = get_ChunkSize(u8NumberOfOrginalTitel-1);
//		u32ChunkSize = u32ChunkSize - u32Subchunk2Size;  //u32Subchunk2Size ist ja nun die Hlfte
//		u8Byte1 = (uint8_t)(u32ChunkSize >> 24);
//		u8Byte2 = (uint8_t)(u32ChunkSize >> 16);
//		u8Byte3 = (uint8_t)(u32ChunkSize >> 8);
//		u8Byte4 =	(uint8_t) u32ChunkSize;
//		set_ChunkSize(u16Titel_Counter-1,u8Byte4, u8Byte3, u8Byte2, u8Byte1);
//	
//		//Neue ByteRate Setzen diese ist nun halb so gro
//		u32ByteRate = get_ByteRate(u8NumberOfOrginalTitel-1);
//		u32ByteRate = u32ByteRate/2;
//		u8Byte1 = (uint8_t)(u32ByteRate >> 24);
//		u8Byte2 = (uint8_t)(u32ByteRate >> 16);
//		u8Byte3 = (uint8_t)(u32ByteRate >> 8);
//		u8Byte4 =	(uint8_t) u32ByteRate;
//		set_ByteRate(u16Titel_Counter-1,u8Byte4, u8Byte3, u8Byte2, u8Byte1);
//								
//		/*********************************************************
//		Schreiben der Werte ins EEPROM und in den Struckt
//		**********************************************************/
//		ResetAdressDatas (u16Titel_Counter-1); 		  	
//		set_EEPROMNumberOfTitels((u16Titel_Counter));
//		CopyStrucktToEEPROM((u16Titel_Counter-1));
//
//
//		/*********************************************************
//		Hier foglgt nun die Manipulation der Nutzdaten
//		Wichtig hierbe ist:
//		 - es gibt Blocklngen von 1 bis 2 Byte
//		 - Die Wertigkeit der einbeitigen Daten reicht von 0 ... 255 (uint8_t)
//		 - Die Wertigkeit der einbeitigen Daten reicht von -32768 ... 32767 (int16_t)
//		 - Bei RIFF little Endian 	FFIR		24080000 = 	2084 Byte1,Byte2,...
//		 - Bei RIFX big Endian		RIFF					  ...Byte2,Byte1
//		**********************************************************/
//
//
//			//Schreiben des Headers
//				
//			SPI_FLASH_BufferRead(u8MetaDataBuffer,u32StartAddrOfOrginalFile,METADATALENGH);//u8SPIMetaDatas);			
//
//			
//			//Setze Format auf Mono == 0x00
//			u16NumChannelsTemp = get_NumChannels(u16Titel_Counter-1);
//			u8MetaDataBuffer[NUMCHANNELS1] = (uint8_t)u16NumChannelsTemp;
//			u8MetaDataBuffer[NUMCHANNELS2] = (uint8_t) (u16NumChannelsTemp >> 8);  
//
//			//Breite einer Stereoinfo ermitteln
//			//Diese setzt sich zusammen aus Rechtem UND linkem Kanal
//			//Also ist R bzw L je die Hlfte
//			u16BlockAlignTemp = get_BlockAlign(u16Titel_Counter-1);
//			u8MetaDataBuffer[BLOCKALIGN1] =	(uint8_t)u16BlockAlignTemp;
//			u8MetaDataBuffer[BLOCKALIGN2] =	(uint8_t) (u16BlockAlignTemp >> 8);
//			 
//
//			//Neue lnge des Datenblocks  == alte/2 da je zwei Stereoinfos (L&&R) ein Monobyte werden
//			//Low -> High 
//			u32Subchunk2SizeTemp = get_Subchunk2Size(u16Titel_Counter-1);
//			u8MetaDataBuffer[SUBCHUNK2SIZE1] = (uint8_t)u32Subchunk2SizeTemp;
//			u8MetaDataBuffer[SUBCHUNK2SIZE2] = (uint8_t)(u32Subchunk2SizeTemp >> 8);
//			u8MetaDataBuffer[SUBCHUNK2SIZE3] = (uint8_t)(u32Subchunk2SizeTemp >> 16);
//			u8MetaDataBuffer[SUBCHUNK2SIZE4] = (uint8_t)(u32Subchunk2SizeTemp >> 24);
//			
//
//			//Neue lnge des Files  == alte/2 da je zwei Stereoinfos (L&&R) ein Monobyte werden
//			u32ChunkSizeTemp = get_ChunkSize(u16Titel_Counter-1);
//			u8MetaDataBuffer[CHUNKSIZE1] = (uint8_t)u32ChunkSizeTemp;
//			u8MetaDataBuffer[CHUNKSIZE2] = (uint8_t)(u32ChunkSizeTemp >> 8);
//			u8MetaDataBuffer[CHUNKSIZE3] = (uint8_t)(u32ChunkSizeTemp >> 16);
//			u8MetaDataBuffer[CHUNKSIZE4] = (uint8_t)(u32ChunkSizeTemp >> 24);
//
//			//Neue ByteRate Setzen diese ist nun halb so gro
//			u32ByteRateTemp = get_ByteRate(u16Titel_Counter-1);
//			u8MetaDataBuffer[BYTERATE1] = (uint8_t)u32ByteRateTemp;
//			u8MetaDataBuffer[BYTERATE2] = (uint8_t)(u32ByteRateTemp >> 8);
//			u8MetaDataBuffer[BYTERATE3] = (uint8_t)(u32ByteRateTemp >> 16);
//			u8MetaDataBuffer[BYTERATE4] = (uint8_t)(u32ByteRateTemp >> 24);	 
//
//
//			SPI_FLASH_BufferWrite(u8MetaDataBuffer,u32StartAddrForConvertedFile,METADATALENGH);//u8SPIMetaDatas);			
// 
//
//			//Hier morgen weitemachen
//			//Kopieren der Nutzdaten
//			//Nutzdatenlnge Vorher = 	get_Subchunk2Size(u8Titel-1); 
//			//Nutzdatenlnge Nachher get_EndAdress((u16Titel_Counter-1))+1;	
//		if(get_BlockAlign(u8Titel-1) == ONEBYTEPERCHANNELSTEREO)
//		{
//			//u8Byte1L u8Byte1R
//			uint8_t  s8Byte1L;		 //Left allways befor Right
//			uint8_t  s8Byte1R;
//
//			uint8_t s8Nutzdatenpuffer[BUFFER_VALUE];
//			uint8_t s8Rohdatenpuffer[2];
//
//			uint16_t s16Mono = 0;
//
//			uint32_t u32Gesamtumlaufe;
//
//			u32DataReadAddr = u32DataReadAddr+METADATALENGH;
//			u32DataWriteAdress = u32DataWriteAdress+METADATALENGH;
//
//			for(u32Gesamtumlaufe = 0 ; u32Gesamtumlaufe< get_Subchunk2Size(u8Titel-1) ; u32Gesamtumlaufe++)
//			{		
//				SPI_FLASH_BufferRead(s8Rohdatenpuffer,u32DataReadAddr,2);				
//				s8Byte1L = s8Rohdatenpuffer[0];
//				s8Byte1R = s8Rohdatenpuffer[1];
//				s16Mono = (s8Byte1L+s8Byte1R)/2;
//				u32DataReadAddr += 2;
//				
//			   	s8Nutzdatenpuffer[u8NutzdatenCounter] = s16Mono;
//					
//				if(u8NutzdatenCounter == PAGESIZE || u32Gesamtumlaufe == get_Subchunk2Size(u8Titel-1))
//				{
//					SPI_FLASH_BufferWrite((uint8_t*)s8Nutzdatenpuffer,(u32StartAddrForConvertedFile + METADATALENGH)+BUFFER_VALUE*u16PageCounter,u8NutzdatenCounter);
//					u16PageCounter++;
//				}
//
//				u8NutzdatenCounter++;
//			}
//			u8NutzdatenCounter= 0;
//			GUIFileConverted();
//		}
//
//
//		else if(get_BlockAlign(u8Titel-1) == TWOBYTEPERCHANNELSTEREO)
//		{
//			//Low Links | High Links | Low Rechts | High Rechts
//			//u8Byte1L 	| u8Byte2L	 | u8Byte1R   |	u8Byte2R
//			int8_t  s8Byte1L;		 //Left allways befor Right
//			int8_t  s8Byte2L;		 
//			int8_t  s8Byte1R;
//			int8_t  s8Byte2R;
//	
//			int16_t  s16ByteL;
//			int16_t  s16ByteR;
//	
//			int32_t  s32Mono;
//
//			uint8_t s8Nutzdatenpuffer[BUFFER_VALUE];
//			uint8_t s8Rohdatenpuffer[4];
//
//			uint32_t u32Gesamtumlaufe;
//
//			u32DataReadAddr = u32DataReadAddr+METADATALENGH;
//			u32DataWriteAdress = u32DataWriteAdress+METADATALENGH;
//
//			for(u32Gesamtumlaufe = 0 ; u32Gesamtumlaufe< get_Subchunk2Size(u8Titel-1) ; u32Gesamtumlaufe++)
//			{		
//				SPI_FLASH_BufferRead(s8Rohdatenpuffer,u32DataReadAddr,4);				
//
//				
//				s8Byte1L = s8Rohdatenpuffer[0];
//				s8Byte2L = s8Rohdatenpuffer[1];
//				s8Byte1R = s8Rohdatenpuffer[2];
//				s8Byte2R = s8Rohdatenpuffer[3];
//	
//				s16ByteL = (s8Byte2L << 8);
//				s16ByteL |= s8Byte1L;
//	
//				s16ByteR = (s8Byte2R << 8);
//				s16ByteR |= s8Byte1R;				
//	
//				s32Mono = (s16ByteL+s16ByteR)/2;
//				u32DataReadAddr += 4;
//				
//			   	s8Nutzdatenpuffer[u8NutzdatenCounter] = (int8_t)(s32Mono >> 8);
//				u8NutzdatenCounter++;
//				s8Nutzdatenpuffer[u8NutzdatenCounter] = (int8_t)s32Mono;
//					
//				if(u8NutzdatenCounter == PAGESIZE || u32Gesamtumlaufe == get_Subchunk2Size(u8Titel-1))
//				{
//					SPI_FLASH_BufferWrite((uint8_t*)s8Nutzdatenpuffer,(u32StartAddrForConvertedFile + METADATALENGH)+BUFFER_VALUE*u16PageCounter,u8NutzdatenCounter);
//					u16PageCounter++;
//				}
//
//				u8NutzdatenCounter++;
//			}
//			u8NutzdatenCounter= 0;
//			GUIFileConverted();
//		}
//		else
//		{
//			GUIBlocklengh_Not_Supported();
//		}
//	
//		//Falls noch METADATAS dahinter kommen werden diese nun auch kopiert
//		if(get_ChunkSize((u16Titel_Counter-1)) > METADATALENGH + get_Subchunk2Size(u16Titel_Counter-1))	 //Ende des Vorherigen +1
//		{
//			uint8_t u8MetaBuffer1[1];
//			uint8_t u8MetaBuffer2[PAGESIZE];
//			uint32_t u32Gesamtumlaufe;
//			for(u32Gesamtumlaufe = 0 ; u32Gesamtumlaufe< get_ChunkSize(u16Titel_Counter-1)-METADATALENGH-get_Subchunk2Size(u16Titel_Counter-1) ; u32Gesamtumlaufe++)
//			{		
//				SPI_FLASH_BufferRead(u8MetaBuffer1,u32DataReadAddr,1);				
//				u8MetaBuffer2[u8NutzdatenCounter] = u8MetaBuffer1[0];
//				
//					
//				if(u8NutzdatenCounter == PAGESIZE || u32Gesamtumlaufe == METADATALENGH + get_Subchunk2Size(u16Titel_Counter-1))
//				{
//					SPI_FLASH_BufferWrite(u8MetaBuffer2,(u32StartAddrForConvertedFile + METADATALENGH)+ get_Subchunk2Size(u16Titel_Counter-1) +BUFFER_VALUE*u16PageCounter,u8NutzdatenCounter);
//					u16PageCounter++;
//				}
//
//				u8NutzdatenCounter++;
//			}
//			u8NutzdatenCounter= 0;
//			GUIFileConverted();	
//		}
//	
//	}
//
//	else
//	{
//		GUIFileIsMonoConversioDontNeeded();
//	}
}

/**
  * \brief  Sinus
  *
  * Diese Funktion gerneriert den Testsinus
  *
  * \param	parameter   uint16_t u16SinusFrequenz
  						uint16_t u16FixSampling0OrQuantisation
						uint16_t u16FixValue
						uint8_t u8LevelInPercent
  * \return	            none
  *
  */

void Sinus (uint16_t u16SinusFrequenz, uint16_t u16FixSampling0OrQuantisation, uint16_t u16FixValue, uint8_t u8LevelInPercent)
{
 #ifdef TESTSINUS_ON
 uint16_t u16test;
 const float pi = 3.1415927;

 uint16_t u16AnzStepsX = 0;
 uint16_t u16QuantisationMax = 0;

 DMAVarInit();

	if(u16FixSampling0OrQuantisation == FIX_SAMPLING)
	{	 
		/*Bsp 
		CPU		   		72000000Hz -	1.38*10^-8s
		Sampling     	  44100 Hz - 2.26*10^-5s
		Sinus               1000Hz - 0.001s
		AnzStepsX       tSinus/tSampling   = 	44
		TimePerStep		AnzStepsX*tCPU = Sampling
		QuantisaionMax  tSampling/tCPU = 1632 
		*/	
		float tSinus     = 1.0/u16SinusFrequenz;
		float tCPU		 = 1.0/TIMFREQUENZ;
		float tSampling	 = 1.0/u16FixValue;

		u16AnzStepsX = (uint16_t)(tSinus/tSampling);
		u16QuantisationMax = (uint16_t)(tSampling/tCPU);

		

		for(u16test = 0; u16test < u16AnzStepsX ; u16test++)
		{
			u16DoubleBuffer1[u16test] = (uint16_t)((sin(u16test*2*pi/u16AnzStepsX)*(u8LevelInPercent+40)/100+1)*u16QuantisationMax/2);
		}
		DOUBLE_BUFFER_1_SET_FULL();
		DOUBLE_BUFFER_1_SET_READY();

		for(u16test = 0; u16test < u16AnzStepsX ; u16test++)
		{
			u16DoubleBuffer2[u16test] = (uint16_t)((sin(u16test*2*pi/u16AnzStepsX)*(u8LevelInPercent+80)/100+1)*u16QuantisationMax/2);
		}
		DOUBLE_BUFFER_2_SET_FULL();
		DOUBLE_BUFFER_2_SET_READY();

	}

	else if(FIX_QUANTIFICATION)
	{

	}

	else
	{
	 	GUIFunctionNotSupported();
		return;
	}
	RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);
	NVIC_Configuration_DMA();
	RCC_Configuration_PWM();
	GPIO_Configuration_PWM();

	u16MasterBufferDataSize = u16AnzStepsX;
	u16BytesToTransferPerDMACycle = u16AnzStepsX * 2;

	StartDMATransferToSpeaker(u16AnzStepsX);
	//void InitPWM(uint16_t u16Periode, uint16_t u16Prescaler, uint16_t u16_ClockDivision)
    InitPWM((uint16_t)u16QuantisationMax,0,0); 
	#endif //TESTSINUS_ON
}

/**
  * \brief  InitTesttone
  *
  * Diese Funktion initialisiert die Variablen der Sinustestroutine
  *
  * \param	parameter   none
  * \return	            none
  *
  */

void InitTesttone (void)
{
	u8EngoingStatus = 0;
  	u16EngoingSinusFrequenz = 1000;//172;
  	u8EngoingFixSampling0OrQuantisation = 0;
  	u16EngoingFixValue = 44100;
  	u16EngoingLevelInPercent = 10;
}

/**
  * \brief  DSPPlayTitel
  *
  * Diese Funktion aktiviert die Widergabe eines Audiofils
  *
  * \param	parameter   uint8_t u8Titel
  * \return	            none
  *
  */

void DSPPlayTitel(uint8_t u8Titel)
{
	StartDMATransferToBuffer(u8Titel);	
}

#undef __DSP_C
