#define __MENUE_C

#include "global.h"
#include "menue.h"
#include "math.h"
#include "usb_endp.h"
#include "menue_GUI.h"

#pragma O3

/**
  * \brief  Text_to_Array
  *
  * Wandelt einen Text in ein Array aus Zeichen welches in einem Struct liegt.
  * Dieser enthlt die lnge des Strings
  *
  * \param	parameter   char* cstring
  * \return	            struct  Textinfo *
  *
  */
struct  Textinfo *Text_to_Array (char* cstring)
{
	uint16_t u16Temp;
	
	for(u16Temp = 0x00 ; u16Temp < BUFFER_VALUE ; u16Temp++)
	{
		sText.Text[u16Temp] = 0x00;	
	}

	for(u16Temp = 0 ; cstring[u16Temp] != '\0' ; u16Temp++)
	{
		sText.Text[u16Temp] = cstring[u16Temp];			
	}
	sText.size = u16Temp+1;
	return	&sText;
}

/**
  * \brief  Hex_to_IntArray
  *
  * Wandelt eine Zahl in ein Array aus Zeichen welches in einem Struct liegt.
  * Dieser enthlt die lnge des Strings
  *
  * \param	parameter   uint32_t u32Number
  * \return	            struct  Numberinfo *
  *
  */
struct  Numberinfo *Hex_to_IntArray (uint32_t u32Number)
{
	uint8_t u8Umkopieren;
	uint8_t u8Umdrehen;
	uint8_t u8Stelle  = 0x09;
	uint8_t u8Multiplikator = 0x00;
	uint8_t u8Freigabe = 0x00;
	const uint8_t cu8Basis = 0x0A;


	//Wenn Wert Null ist auch Null ausgeben dazu counter erhhen
	if(u32Number == 0)
	{
		sNumber.Text[0] = 0x00;
		sNumber.size = 0x01;
	}
	else
	{	
		//Array lschen
		for(u8Umkopieren = 0x00 ; u8Umkopieren <= 9 ; u8Umkopieren++)
		{
			sNumber.Text[u8Umkopieren] = 0x00;	
		}
	
	
		//Umrechnen in Dez
		u8Umdrehen = 0;
		for(u8Stelle = 0x09 ; u8Stelle != 0xFF ; u8Stelle--)
		{
			uint32_t Abzug = pow(cu8Basis,u8Stelle);
			u8Multiplikator = 0x00;
			while(u32Number >= Abzug)
			{
				u32Number = u32Number-pow(cu8Basis,u8Stelle);
				u8Multiplikator++;
				u8Freigabe = 0xFF;	
			}
			sNumber.Text[u8Umdrehen] = u8Multiplikator;
			if(u8Freigabe!= 0x00)
			{	
				u8Umdrehen++;
			}
		}	
	
		sNumber.size = u8Umdrehen;
	}

	for(u8Umkopieren = 0x00 ; u8Umkopieren <= (sNumber.size-1) ; u8Umkopieren++)
	{
		sNumber.Text[u8Umkopieren] = sNumber.Text[u8Umkopieren]+0x30;	
	}

	return	&sNumber;	
}

/**
  * \brief  Input_Ascii_to_Hex
  *
  * Konvertiert einen eingegebenen Zahlenstring in eine HEX Zahl
  *
  * \param	parameter   none
  * \return	            uint16_t
  *
  */
uint16_t Input_Ascii_to_Hex (void)
{
	uint8_t u8Counter = 0;
	uint8_t u8Potenz = 0;
	uint8_t u8Umdreher = 0;
	uint8_t u16NewValue = 0;
	uint16_t u16Result = 0;
	uint8_t u8Basis = 10;
	uint8_t u8NumerArray[10];

	u8Buffer_Out[0] = 0x00;

	while(u8Buffer_Out[0] == 0x00){;} 


	while(u8Buffer_Out[0] != 0x0D)	//Warten bis eim Zeichen empfangen wurde
	{
		u16NewValue = ((u8Buffer_Out[0])-0x30);
		if(u16NewValue < 10 && u8Buffer_Out[0] != 0x0D)
		{
			if(u32Count_Out != 0 && u8Buffer_Out[0] != 0x0D)
			{
					u8NumerArray[u8Counter] = u8Buffer_Out[0]-0x30;
					u8Counter++;
					u32Count_Out = 0;
			}
		}
		else if(u8Buffer_Out[0] != 0xFF && u8Buffer_Out[0] != 0x0D)
		{
			ClearLastCaracter();
			u8Buffer_Out[0] = 0xFF;
		}				 
	}
	u8Potenz = u8Counter;
	for(u8Umdreher = 0x00 ; u8Umdreher <u8Counter ; u8Umdreher++)
	{
		u16Result = u16Result + u8NumerArray[u8Umdreher]*pow(u8Basis,u8Potenz-1);
		u8Potenz--;	
	} 


	return	u16Result;	
}


#pragma O3


#undef __MENUE_C
