#define __INTERRUPT_C


/******************** (C) COPYRIGHT 2010 STMicroelectronics ********************
* File Name          : stm32f10x_it.c
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 04/07/2010
* Description        : Main Interrupt Service Routines.
*                      This file provides template for all exceptions handler
*                      and peripherals interrupt service routine.
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "stm32f10x_it.h"
#include "usb_lib.h"
#include "usb_istr.h"
#include "hw_config.h"
#include "usb_endp.h"

/* Private typedef -----------------------------------------------------------*/
/* Private define ------------------------------------------------------------*/
/* Private macro -------------------------------------------------------------*/
/* Private variables ---------------------------------------------------------*/
/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

/******************************************************************************/
/*            Cortex-M3 Processor Exceptions Handlers                         */
/******************************************************************************/

/*******************************************************************************
* Function Name  : NMI_Handler
* Description    : This function handles NMI exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void NMI_Handler(void)
{
}

/*******************************************************************************
* Function Name  : HardFault_Handler
* Description    : This function handles Hard Fault exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void HardFault_Handler(void)
{
  /* Go to infinite loop when Hard Fault exception occurs */
  while (1)
  {
  }
}

/*******************************************************************************
* Function Name  : MemManage_Handler
* Description    : This function handles Memory Manage exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void MemManage_Handler(void)
{
  /* Go to infinite loop when Memory Manage exception occurs */
  while (1)
  {
  }
}

/*******************************************************************************
* Function Name  : BusFault_Handler
* Description    : This function handles Bus Fault exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void BusFault_Handler(void)
{
  /* Go to infinite loop when Bus Fault exception occurs */
  while (1)
  {
  }
}

/*******************************************************************************
* Function Name  : UsageFault_Handler
* Description    : This function handles Usage Fault exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void UsageFault_Handler(void)
{
  /* Go to infinite loop when Usage Fault exception occurs */
  while (1)
  {
  }
}

/*******************************************************************************
* Function Name  : SVC_Handler
* Description    : This function handles SVCall exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SVC_Handler(void)
{
}

/*******************************************************************************
* Function Name  : DebugMon_Handler
* Description    : This function handles Debug Monitor exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void DebugMon_Handler(void)
{
}

/*******************************************************************************
* Function Name  : PendSV_Handler
* Description    : This function handles PendSVC exception.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void PendSV_Handler(void)
{
}

/*******************************************************************************
* Function Name  : SysTick_Handler
* Description    : This function handles SysTick Handler.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void SysTick_Handler(void)
{
}

/******************************************************************************/
/*            STM32F10x Peripherals Interrupt Handlers                        */
/******************************************************************************/

#ifndef STM32F10X_CL
/*******************************************************************************
* Function Name  : USB_LP_CAN1_RX0_IRQHandler
* Description    : This function handles USB Low Priority or CAN RX0 interrupts
*                  requests.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USB_LP_CAN1_RX0_IRQHandler(void)
{
  USB_Istr();
}
#endif /* STM32F10X_CL */

#if defined (USE_STM3210B_EVAL) || defined (USE_STM3210E_EVAL)
/*******************************************************************************
* Function Name  : USART1_IRQHandler
* Description    : This function handles USART1 global interrupt request.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/

/**
  * \brief  USART1_IRQHandler
  *
  * Hier befindet sich die Routine zur Kommunikation ber den LIN Bus 
  *
  * \param	parameter   none
  * \return	            none
  *
  */

void USART1_IRQHandler(void)
{
//	//LIN_BREAK
//  if(USART_GetITStatus(USART1,USART_IT_LBD) != RESET)
//  {
//    USART_ClearITPendingBit(USART1, USART_IT_LBD);
//	u8LIN_BREAK_detected = true;
//	
//	u8LIN_RECIEVE_begin = false;
//	//Recived_Bytes = 0x00;
//  }
//  	//LIN_RECEIVE
//  if (USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)  //RX interrupt
//  {
//  	if(u8LIN_BREAK_detected == true)
//	{
//		u8LIN_BREAK_detected = false;
//		u8LIN_RECIEVE_begin = true;
//		u8Recived_Bytes = 0x00;
//	}
//
//	if(u8LIN_RECIEVE_begin == true)
//	{
//		u8 HEX_temp_low;
//		u8 HEX_temp_high;
//		
//
//		u8LIN_RECIVED_Datas[u8Recived_Bytes] = USART_ReceiveData(USART1);
//		u8Recived_Bytes++;
//
//		HEX_temp_low = USART_ReceiveData(USART1);
//		HEX_temp_high  = HEX_temp_low;
//		HEX_temp_low = HEX_temp_low & 0x0f;
//		HEX_temp_high = HEX_temp_high & 0xf0;
//		HEX_temp_high =	HEX_temp_high >> 4;
//
//		u8Buffer_Out[0] = HEX_TO_INT(HEX_temp_high);
//		u8Buffer_Out[1] =  HEX_TO_INT(HEX_temp_low);
//		u8Buffer_Out[2] =  0x20;
//				
//		USB_SIL_Write(EP1_IN, u8Buffer_Out, 3);
//  		SetEPTxValid(ENDP1);
//
//
//		//Im puffer steht Sync  ID Data 0..	6 CRC LCS
//		
//		if(u8Recived_Bytes >4 && u8LIN_RECIVED_Datas[1] == 0xC1)
//		{
//			int x;
//			u8 y = 0; 
//			
//
//			u8LIN_RECIEVE_begin = false;
//			//LIN_RECIVED_Datas[Recived_Bytes] = 13;
//			u8Recived_Bytes = 0x00;
//
//			
//			for(x = 1 ; x < 5 ; x++)
//			{
//				//convert HEX to ASCII for EXAMPLE 0x55 to '5' '5'
//				HEX_temp_low = u8LIN_RECIVED_Datas[x];
//				HEX_temp_high  = HEX_temp_low;
//				HEX_temp_low = HEX_temp_low & 0x0f;
//				HEX_temp_high = HEX_temp_high & 0xf0;
//				HEX_temp_high =	HEX_temp_high >> 4;
//
//				u8Buffer_Out[y] = HEX_TO_INT(HEX_temp_high);
//				y++;
//				u8Buffer_Out[y] =  HEX_TO_INT(HEX_temp_low);
//				y++;
//				u8Buffer_Out[y] =  0x20;
//				y++;
//			}
//			u8Buffer_Out[y] = 0x0D;
//				
//			USB_SIL_Write(EP1_IN, u8Buffer_Out, 13);
//  			SetEPTxValid(ENDP1);
//
//			for(u8LinLaufvar = 0 ; u8LinLaufvar < 11 ; u8LinLaufvar ++)
//			{
//				u8LIN_RECIVED_Datas[u8LinLaufvar] = 0x00;	
//			}
//			
//			for(u8LinLaufvar = 0 ; u8LinLaufvar < 63 ; u8LinLaufvar ++)
//			{
//				u8Buffer_Out[u8LinLaufvar] = 0x00;	
//			}	
//		}
//
//
//		else if(u8Recived_Bytes >10)
//		{
//			int x;
//			u8 y = 0;
//
//			u8LIN_RECIEVE_begin = false;
//			//LIN_RECIVED_Datas[Recived_Bytes] = 13;
//			u8Recived_Bytes = 0x00;
//
//			for(x = 1 ; x < 11 ; x++)
//			{
//				//buffer_out[x]  = LIN_RECIVED_Datas[x];
//				HEX_temp_low = u8LIN_RECIVED_Datas[x];
//				HEX_temp_high  = HEX_temp_low;
//				HEX_temp_low = HEX_temp_low & 0x0f;
//				HEX_temp_high = HEX_temp_high & 0xf0;
//				HEX_temp_high =	HEX_temp_high >> 4;
//
//				u8Buffer_Out[y] = HEX_TO_INT(HEX_temp_high);
//				y++;
//				u8Buffer_Out[y] =  HEX_TO_INT(HEX_temp_low);
//				y++;
//				u8Buffer_Out[y] =  0x20;
//				y++;
//			}
//			u8Buffer_Out[y] = 0x0D;
//			USB_SIL_Write(EP1_IN, u8Buffer_Out, 33);
//  			SetEPTxValid(ENDP1);
//
//			for(u8LinLaufvar = 0 ; u8LinLaufvar < 11 ; u8LinLaufvar ++)
//			{
//				u8LIN_RECIVED_Datas[u8LinLaufvar] = 0x00;	
//			}
//			
//			for(u8LinLaufvar = 0 ; u8LinLaufvar < 63 ; u8LinLaufvar ++)
//			{
//				u8Buffer_Out[u8LinLaufvar] = 0x00;	
//			}	
//		} 
//	}
//
//
//	else
//	{
//		if(USART_ReceiveData(USART1) == 0x80)
//		{
//			u8WakeUp_detect = true;	
//		}
//		else
//		{
//			u8WakeUp_detect = false;	
//		}
//	}
//  }
//
//   	//LIN_TRANSMIT
//  if (USART_GetITStatus(USART1, USART_IT_TC) != RESET)
//  {
//   	  u8Transmission_Complett = true;
//	  USART_ClearITPendingBit(USART1, USART_IT_TC);
//  }
}
#endif /* USE_STM3210B_EVAL or USE_STM3210E_EVAL */

#ifdef USE_STM3210C_EVAL
/*******************************************************************************
* Function Name  : USART2_IRQHandler
* Description    : This function handles USART2 global interrupt request.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void USART2_IRQHandler(void)
{
/*
  if (USART_GetITStatus(USART2, USART_IT_RXNE) != RESET)
  {
    // Send the received data to the PC Host
    USART_To_USB_Send_Data();
  }

  // If overrun condition occurs, clear the ORE flag and recover communication   
  if (USART_GetFlagStatus(USART2, USART_FLAG_ORE) != RESET)
  {
    (void)USART_ReceiveData(USART2);
  }
  */
}
#endif /* USE_STM3210C_EVAL */

#ifdef STM32F10X_CL
/*******************************************************************************
* Function Name  : OTG_FS_IRQHandler
* Description    : This function handles USB-On-The-Go FS global interrupt request.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
void OTG_FS_IRQHandler(void)
{
  STM32_PCD_OTG_ISR_Handler(); 
}
#endif /* STM32F10X_CL */

/******************************************************************************/
/*                 STM32F10x Peripherals Interrupt Handlers                   */
/*  Add here the Interrupt Handler for the used peripheral(s) (PPP), for the  */
/*  available peripheral interrupt handler's name please refer to the startup */
/*  file (startup_stm32f10x_xx.s).                                            */
/******************************************************************************/

/*******************************************************************************
* Function Name  : PPP_IRQHandler
* Description    : This function handles PPP interrupt request.
* Input          : None
* Output         : None
* Return         : None
*******************************************************************************/
/*void PPP_IRQHandler(void)
{
}*/

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/


/**
  * \brief  HEX_TO_INT
  *
  * Dieser Funktion wird ein HEX Wert bergeben.
  * Sie liefert das dazugehrige ASCII Zeichen
  * \param	parameter   uint8_t HEX
  * \return	            uint8_t
  *
  */

uint8_t HEX_TO_INT (uint8_t HEX)
{
	if (HEX <= 0x09)
	 return HEX + 0x30;
	else
	 return HEX + 0x37; 	
}


/**
  * \brief  LINVarInit
  *
  * Initialisiert die variablen fr die LIN Kommunikation 
  *
  * \param	parameter   none
  * \return	            none
  *
  */
void LINVarInit (void)
{
	u8LinLaufvar = 0;
}

#undef	__INTERRUPT_C
