#define __USB_ENDP_C

/******************** (C) COPYRIGHT 2010 STMicroelectronics ********************
* File Name          : usb_endp.c
* Author             : MCD Application Team
* Version            : V3.1.1
* Date               : 04/07/2010
* Description        : Endpoint routines
********************************************************************************
* THE PRESENT FIRMWARE WHICH IS FOR GUIDANCE ONLY AIMS AT PROVIDING CUSTOMERS
* WITH CODING INFORMATION REGARDING THEIR PRODUCTS IN ORDER FOR THEM TO SAVE TIME.
* AS A RESULT, STMICROELECTRONICS SHALL NOT BE HELD LIABLE FOR ANY DIRECT,
* INDIRECT OR CONSEQUENTIAL DAMAGES WITH RESPECT TO ANY CLAIMS ARISING FROM THE
* CONTENT OF SUCH FIRMWARE AND/OR THE USE MADE BY CUSTOMERS OF THE CODING
* INFORMATION CONTAINED HEREIN IN CONNECTION WITH THEIR PRODUCTS.
*******************************************************************************/

/* Includes ------------------------------------------------------------------*/
#include "usb_lib.h"
#include "usb_desc.h"
#include "usb_mem.h"
#include "hw_config.h"
#include "usb_istr.h"
#include "usb_endp.h"
#include "global.h"



/* Private function prototypes -----------------------------------------------*/
/* Private functions ---------------------------------------------------------*/

void VarInit_USBEndp (void)
{
	  u32Count_Out = 0;
	  count_in = 0;
	  u8BufferControl = Buffer0;
	  u8BufferFilled  = 0x00;
	  u8EndOfFile = 0x00;
}

/*******************************************************************************
* Function Name  : EP1_IN_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP1_IN_Callback(void)
{
  count_in = 0;
}

/*******************************************************************************
* Function Name  : EP3_IN_Callback
* Description    :
* Input          : None.
* Output         : None.
* Return         : None.
*******************************************************************************/
void EP3_OUT_Callback(void)
{
	uint16_t i;
  /* Get the received data buffer and update the counter */
  u32Count_Out = USB_SIL_Read(EP3_OUT, u8Buffer_Out);

  for (i = 0; i < u32Count_Out; i++)
  {
  	 u64Audio_Total_Byte_Counter++;
  	 if(u8BufferControl == Buffer0)
  	 {
	  	u8User_Buffer_Datas_From_PC0[u16Counter_Datas_From_PC0] = u8Buffer_Out[i];
		u16Counter_Datas_From_PC0++;
		if(u16Counter_Datas_From_PC0 > BUFFER_VALUE-1)
  		{
			u16Counter_Datas_From_PC0 = 0x0000;
			u8BufferControl = Buffer1;
			u8BufferFilled = Buffer0;			
  		}
     }

  	 else if(u8BufferControl == Buffer1)
     {
	  	u8User_Buffer_Datas_From_PC1[u16Counter_Datas_From_PC1] = u8Buffer_Out[i];
		u16Counter_Datas_From_PC1++;
		if(u16Counter_Datas_From_PC1 > BUFFER_VALUE-1)
		{
			u16Counter_Datas_From_PC1 = 0x0000;
			u8BufferControl = Buffer0;
			u8BufferFilled = Buffer1;			
		}
     }
  }

  if(u64Audio_Total_Byte_Counter >= u32Audio_Byte_Counter_Max_Value && u64Audio_Total_Byte_Counter > 256)
  {
  	u8EndOfFile = 0xFF;
  } 
    
#ifndef STM32F10X_CL
  /* Enable the receive of data on EP3 */
  SetEPRxValid(ENDP3);
#endif /* STM32F10X_CL */
}

/******************* (C) COPYRIGHT 2010 STMicroelectronics *****END OF FILE****/

#undef __USB_ENDP_C

